var TaskMgr = false;
var Statusgrid = {

	// Base URL for grid requests
	baseURL: "/opmon/seagull/www/index.php/statusgrid/action/",

	loadGrid: function(loadContext) {

		loadContext = loadContext || false;
		if (loadContext) {
			var context = Ext.get('gridContextPanel');
			if (context) {
				var contextURL = this.baseURL + context.dom.value + "/";
				if (parent.createContextSensitivePanel) {
					var contextLoaded = parent.Ext.get(context.dom.value);
					if (!contextLoaded)
						parent.createContextSensitivePanel( [contextURL] );
				}
			}
		}

		var loadShortcutPanel = Ext.get('gridShortcutPanel');
		if (loadShortcutPanel && parent.loadShortcut) {
			parent.loadShortcut(loadShortcutPanel.dom.value);
		}

		if (!TaskMgr)
			TaskMgr = new Ext.util.DelayedTask(this.loadGrid);

		TaskMgr.cancel();

		// Refresh icon
		var icon = Ext.get('gridRefresh');
		if (icon)
			icon.dom.src = icon.dom.src.replace("refresh", "loading");

		var action = Ext.get('gridName').dom.value;
		var params = Ext.get('gridParams').dom.value;
		var filter = Ext.get('gridFilter').dom.value;

		// ajax request
		var URL = Statusgrid.baseURL + action + "/?" + params;
		if (filter.length)
			URL += "&filter=" + filter;

		Ext.Ajax.request({
			url: URL,
			method: 'POST',
			callback: Statusgrid.processRequest
		});

	},
	closeConfigurationWindow: function() {
		var body;
		var div;

		body = document.getElementsByTagName('body')[0];
		div = document.getElementById('confwindow');
		body.removeChild(div);
		div = document.getElementById('confwindow_mask');
		body.removeChild(div);
	},
	openConfigurationWindow: function(data) {
		var url;
		var modaltemplate;
		var modalwidth;
		var modalheight;

		if (data.title === undefined) 
			data.title = langArray["Configurations"];

		if (data.width === undefined)
			data.width = 810;

		if (data.height === undefined)
			data.height = 535;

		modalwidth = data.width - 10;
		modalheight =  data.height - 36;

		url = "/opmon/seagull/modules/discovery/templates/wizardext/app.php?"+encodeURIComponent(JSON.stringify(data));
		WIZZARD_CONFIG_PARAMS = data;

		modaltemplate = "<div id='confwindow' style='width:" + data.width + "px; height:" + data.height + "px; margin-top:-" + data.height/2 + "px; margin-left:-" + data.width/2 + "px; top:50%; left:50%;' class='fakext-modal'>" +
					"<div class='fakext-modalheader'>" + 
						"<div class='fakext-modalname'>" + data.title + "</div>" +
							"<a onclick='javascript:Statusgrid.closeConfigurationWindow()' class='fakext-modalclose'><span>Close modal</span></a>" +
						"</div>" +
						"<div class='fakext-modalbody'>" +
							"<iframe frameborder='0' width='" + modalwidth + "' height='" + modalheight + "' src='" + url + "'></iframe>" +
						"</div>" +
					"</div>" +
				"</div>" +
				"<div id='confwindow_mask' class='fakext-modalmask'>" +
				"</div>";

		document.getElementsByTagName('body')[0].innerHTML += modaltemplate;
	},
	getSelectedHostNamesOnHostStatusGrid: function() {
		var rows;
		var row;
		var tds;
		var hostNames = [];
		var cols;

		cols = Ext.query(".host-selection-box");
		for(var i=0; i<cols.length; i++) {
			if (!cols[i].checked)
				continue;

			hostNames.push(cols[i].attributes.getNamedItem('hostname').nodeValue);
		}

		return hostNames;

	},
	getSelectedServiceDescriptionsOnServiceStatusGrid: function() {

		var services = [];
		var boxes = [];

		boxes = Ext.query(".service-selection-box");
		for(var i=0; i<boxes.length; i++) {
			if (!boxes[i].checked)
				continue;

			svc = {
				service_description: boxes[i].attributes.getNamedItem('servicedescription').nodeValue,
				host_name: boxes[i].attributes.getNamedItem('hostname').nodeValue
				
			};
			services.push(svc);
		}

		return services;
	},
	processRequest: function(opt,success,resp) {
		// Reschedule next request
		TaskMgr.delay(60000);

		// Check request response
		if (!success)
			return;

		// Process request
		var filter = Ext.get('gridFilter').dom.value;
		try {
			var jsonString = resp.responseText;
			var obj = Ext.util.JSON.decode(jsonString);

			// Clean previous allocated memory
			Ext.each(MemoryMgr, function(memObj,memIndex) {
			if (memObj.destroy)
				memObj.destroy();
			else if (memObj.removeAllListeners)
				memObj.removeAllListeners();
			});

			MemoryMgr = [];

			// Replace data
			Ext.get('gridHeader').dom.innerHTML = obj.header;
			Ext.get('gridHeaderBox').dom.style.display = 'block';
			Ext.get('gridTable').dom.innerHTML = obj.grid;
			Ext.get('gridToolbar').dom.innerHTML = obj.toolbar;
			if (obj.advancedSearch) {
				var adv = Ext.get('gridAdvancedSearch');
				if (adv.dom.style.display == 'none')
					adv.dom.innerHTML = obj.advancedSearch;
			}

			StatusgridEvents.addCheckboxListeners();
			StatusgridEvents.renderComboboxes();
			StatusgridEvents.renderDatetimePicker();

			if (obj.callback)
				eval("StatusgridCallback." + obj.callback + "();");

			var frm = parent.Ext.get('searchForm');
			if (filter.length && parent.frames.length && frm) {

				var oFilter = Ext.util.JSON.decode(filter);
				var input = frm.dom.elements[0];
				input.value = (oFilter.search) ? oFilter.search : "(" + langArray["Filter activated"] + ")";
				if (!input.className.match(" filter-active"))
					input.className += " filter-active";

				var btn = parent.Ext.get("cancelSearch");
				btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
				btn.dom.style.cursor = "pointer";

			} else if (parent.frames.length && frm) {
				var input = frm.dom.elements[0];
				input.value = "";
				if (input.className.match(" filter-active"))
					input.className = "basic-search-input";

				var btn = parent.Ext.get("cancelSearch");
				//btn.dom.src = btn.dom.src.replace("ico-cancela-busca.","ico-cancela-busca-disabled.");
				btn.dom.style.cursor = "default";
			}

			delete(obj);
			delete(jsonString);

		} catch(e) {
			/*
			if (parent.showSystemAlert) {
				parent.showSystemAlert(ALERT_INFO,langArray["Request Error"],langArray["RequestErrorMsg"]);
			}
			*/
		}
	},
	goToPage: function(page) {
		var el = Ext.get('gridParams');
		var str = el.dom.value.replace(/page=[\d]+\&/i,"page=" + page + "&");
		el.dom.value = str;
		this.loadGrid();
	},
	sortGrid: function(sortField) {

		var el = Ext.get('gridParams');

		var reg = /sortBy=(.*)&sortOrder=(.*)$/;
		var arr = reg.exec(el.dom.value);

		var curSortField = arr[1];
		var curSortOrder = arr[2];

		if (curSortField == sortField)
			curSortOrder = (curSortOrder == 'ASC') ? 'DESC' : 'ASC';
		else {
		   curSortField = sortField;
		   curSortOrder = 'ASC';
		}

		
		var str = el.dom.value;
		str = str.replace(arr[1],curSortField);
		str = str.replace(arr[2],curSortOrder);
		el.dom.value = str;

		this.goToPage(1);

	},
	changePageLimit: function(select) {

		var index = select.selectedIndex;
		var value = select.options[index].value;

		var el = Ext.get('gridParams');
		var str = el.dom.value.replace(/limit=[\d]+\&/i,"limit=" + value + "&");
		el.dom.value = str;

		this.goToPage(1);
	},
	inputGoToPage: function(element, e) {

		var code = false;
		if (e.keyCode)
			code = e.keyCode;
		else 
			e.which;
		
		if (code == 13) {
			var page = parseInt(element.value);
			var maxPage = parseInt(Ext.get('gridMaxPage').dom.innerHTML);

			if (page < 1) {
				element.value = 1;
				page = 1;
			} else if (page > maxPage) {
				element.value = maxPage;
				page = maxPage;
			}
			this.goToPage(page);
		}
	},
	rowMouseOver: function(el) {
		el.className += "-selected";
	},
	rowMouseOut: function(el) {
		el.className = el.className.replace("-selected","");
	},
	debug: function(msg) {
		Ext.get('DEBUG').dom.innerHTML += msg + "<br>";
	}
}
