var SelectedElements = [];
var CollapsedElements = [];

var StatusgridEvents = {

	setTitle: function() {
		var title = Ext.get('gridTitle');
		if (title) {
			if (parent.setPageTitle)
				parent.setPageTitle(title.dom.value,0);
		}
	},
	displayRows: function(img) {

		var arr = Ext.query("." + img.id);
		Ext.each( arr, function(obj) {

			var row = Ext.get(obj);
			if (Ext.isIE) {
				row.dom.style.display = (img.src.match("minus")) ? "none" : "block";
			} else {
				row.dom.style.display = (img.src.match("minus")) ? "none" : "table-row";
	   		}
		});

		if (img.src.match("minus")) {
			img.src = img.src.replace("minus","plus");
			var found = 0;
			Ext.each(CollapsedElements, function(str,index) {
				if (str == img.id)
					found = 1;
			});

			if (!found)
				CollapsedElements.push(img.id);
		} else {
			img.src = img.src.replace("plus","minus");
			Ext.each(CollapsedElements, function(str,index) {
			if (str == img.id)
				CollapsedElements.splice(index,1);
			});
		}

	},
	restoreDisplayRows: function() {
		Ext.each(CollapsedElements, function(id) {
			var img = Ext.get(id);
			if (img) {
				StatusgridEvents.displayRows(img.dom);
			}
		});
	},
	getGridCheckboxes: function() {
		return Ext.query('input[classˆ=row-checkbox*]');
	},
	checkAndUncheck: function(main) {

		if (main.checked)
			StatusgridEvents.cookieAddEl(main.id);
		else
			StatusgridEvents.cookieDelEl(main.id);

		var boxes = [];
		boxes = this.getGridCheckboxes();
		Ext.each(boxes, function(cbox) {

			var valid_ids = /^\d+.*$/;

			if (String(cbox.id).match(valid_ids)) {
				cbox.checked = (main.checked);
				StatusgridEvents.verifyCheckbox(false,cbox);
			}
		});
	},
	verifyCheckbox: function(event,cbox) {

		var valid_ids = /^\d+.*$/;

		if (!String(cbox.id).match(valid_ids))
			return;

		if (cbox.id.indexOf("!") < 0) {

			var child_pattern = "^"+cbox.id+"\\!\\d+$";
			var re = new RegExp(child_pattern);
			boxes = StatusgridEvents.getGridCheckboxes();
			for(idx in boxes) {

				if (boxes[idx].id && re.test(boxes[idx].id) || (boxes[idx].classList && boxes[idx].classList.contains('child-'+cbox.id))) {

					boxes[idx].checked = cbox.checked;
					var combo_index = StatusgridEvents.findCheckboxIndex(boxes[idx].id);
					if (boxes[idx].checked && combo_index == -1) {
						SelectedElements.push(boxes[idx].id);
					} else if (combo_index >= 0 && !boxes[idx].checked) {
						SelectedElements.splice(combo_index,1);
					}

					if (cbox.checked)
						StatusgridEvents.cookieAddEl(boxes[idx].id);
					else
						StatusgridEvents.cookieDelEl(boxes[idx].id);

				}
			}
		}

		var index = StatusgridEvents.findCheckboxIndex(cbox.id);
		if (cbox.checked && index == -1) {
			SelectedElements.push(cbox.id);
		} else if (!cbox.checked && index >= 0) {
			SelectedElements.splice(index,1);
		}

		if (cbox.checked)
			StatusgridEvents.cookieAddEl(cbox.id);
		else
			StatusgridEvents.cookieDelEl(cbox.id);


	},
	addService: function() {
		var props = {};
		props.action = "addService";
		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	delService: function() {
		var props = {};
		var i;
		var arr;
		var obj;

		if (SelectedElements.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.services = [];
		for(i=0; i<SelectedElements.length; i++) {
			arr = SelectedElements[i].match(/(\d+)!(\d+)/);
			if (arr === null || arr.length != 3) {
				continue;
			}

			obj = {
				host_id: arr[1],
				service_id: arr[2]
			};
			props.services.push(obj);
		}

		if (props.services.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.action = "deleteServices";
		props.width = 250;
		props.height = 185;
		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);

	},
	cookieAddEl: function(idx) {
		elems = Ext.decode(Ext.util.Cookies.get('previousSelectedElements'));
		if (!elems)
			elems = new Array();

		if (StatusgridEvents.findElemIndex(idx,elems) > -1)
			return;

		elems.push(idx);
		Ext.util.Cookies.set('previousSelectedElements',Ext.encode(elems));
	},
	cookieDelEl: function(idx) {
		elems = Ext.decode(Ext.util.Cookies.get('previousSelectedElements'));
		if (!elems)
			elems = new Array();

		var arr_idx = StatusgridEvents.findElemIndex(idx,elems);
		if (arr_idx < 0)
			return;

		elems.splice(arr_idx,1);
		Ext.util.Cookies.set('previousSelectedElements',Ext.encode(elems));
	},
	findElemIndex: function(elem,arr) {
		for (var i=0; i<arr.length;i++) {
			if (elem == arr[i]) {
				return i;
			}
		}
		return -1;
	},
	addCheckboxListeners: function() {

		var elems = Ext.decode(Ext.util.Cookies.get('previousSelectedElements'));
		if (elems) {
			for (var i=0; i<elems.length; i++) {
				var checkbox = Ext.get(elems[i]);
				if (checkbox) {
					checkbox.dom.checked = true;
					StatusgridEvents.verifyCheckbox(false,checkbox.dom);
				}
			}
		}

		// Add new listeners
		Ext.each( this.getGridCheckboxes(), function(element) {
			var checkbox = Ext.get(element);
			checkbox.on('click',StatusgridEvents.verifyCheckbox);
			MemoryMgr.push(checkbox);
		});

	},
	findCheckboxIndex: function(id) {
		for (var i=0; i<SelectedElements.length;i++) {
			if (id == SelectedElements[i]) {
				return i;
			}
		}
		return -1;
	},
	noElementSelected: function() {

		var win = Ext.getCmp('alertWin');
		if (!win) {
			win = new Ext.Window({
				applyTo: 'alertWin',
				id: 'alertWin',
				contentEl: 'noElementsWin',
				layout: 'fit',
				width: 300,
				autoHeight:	true,
				buttonAlign: 'center',
				plain: false,
				modal: true,
				closable: false,
				closeAction: 'hide',
				draggable: false,
				shadow: false,
				baseCls: 'ext-window',
				bodyBorder: false,
				hideBorders: true,
				border: true,
				resizable: false
			});

		}
		win.center();
		win.show();
	},
	validateBasicSearch: function(form) {
		var obj = form.elements[0];
		var btn = parent.Ext.get("cancelSearch");

		if (obj.value.length) {
			obj.className += " filter-active";

			btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
			btn.dom.style.cursor = "pointer";
		} else {
			if (obj.className.match(" filter-active"))
				obj.className = "basic-search-input";

			btn.dom.style.cursor = "default";
		}

		StatusgridEvents.hideAdvancedSearch();
	},
	cancelSearch: function() {
		var form = parent.Ext.get('searchForm').dom;
		form.reset();
		StatusgridEvents.hideAdvancedSearch();
		parent.mFrame.StatusgridEvents.validateBasicSearch(form);
		form.submit();
	},
	showAdvancedSearch: function() {

		var obj = false;
		var link = false;
		if (parent) {
			obj = parent.mFrame.Ext.get('gridAdvancedSearch');
			var arr = parent.Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
			delete(arr);
		} else {
			obj = mFrame.Ext.get('gridAdvancedSearch');
			var arr = Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
			delete(arr);
		}

		if (obj.dom.style.display == 'block') {
			link.dom.innerHTML = langArray["Advanced options"];
			obj.dom.style.display = 'none';
		} else {
			link.dom.innerHTML = langArray["Hide options"];
			obj.dom.style.display = 'block'
		}
		if (obj) {
			obj.center();
		}
	},
	hideAdvancedSearch: function() {

		var obj = false;
		var link = false;

		if (parent) {
			obj = parent.mFrame.Ext.get('gridAdvancedSearch');
			var arr = parent.Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
		} else {
			obj = mFrame.Ext.get('gridAdvancedSearch');
			var arr = Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
		}

		link.dom.innerHTML = langArray["Advanced options"];
		obj.dom.style.display = 'none';

	},
	validateAdvancedSearch: function(form) {
		var search = false;
		var btn = false;

		if (parent) {
			var arr = parent.Ext.query('.basic-search-input');
		search = arr[0];
			delete(arr);

			btn = parent.Ext.get("cancelSearch");
		} else {
			var arr = Ext.query('.basic-search-input');
			search = arr[0];
			delete(arr);

			btn = Ext.get("cancelSearch");
		}

		search.value = "(" + langArray["Filter activated"] + ")";
		if (!search.className.match(" filter-active")) {
			search.className += " filter-active";
		}

		btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");

		btn.dom.style.cursor = "pointer";

		StatusgridEvents.hideAdvancedSearch();
	},
	renderComboboxes: function() {

		var form = Ext.get('gridAdvancedSearch');
		if (form && form.dom.style.display != 'none') {
			return;
		}

		// Clean previous allocated memory
		Ext.each(FilterMemoryMgr, function(memObj,memIndex) {
			if (memObj.destroy)
			memObj.destroy();
			else if (memObj.removeAllListeners)
				memObj.memObj.removeAllListeners();
		});
		FilterMemoryMgr = [];

		var objs = Ext.query('.combo-autocomplete');
		Ext.each( objs, function(x,index) {
			var obj = Ext.get(x);

			var ds = new Ext.data.Store({
				proxy: new Ext.data.HttpProxy({
					url: '/opmon/seagull/www/index.php/statusgrid/action/comboContent/filter/' + obj.id,
					method: 'post'
				}),
				reader: new Ext.data.JsonReader({
					root: 'data',
					totalProperty: 'total',
					id: 'id'
				},[
					{name: 'id', mapping: 'id'},
					{name: 'display_name', mapping: 'display_name'}
				])
			});

			FilterMemoryMgr.push(ds);

			var content = obj.dom.innerHTML;
			obj.dom.innerHTML = "";
			var combo = new Ext.form.ComboBox({
					store: ds,
					displayField: 'display_name',
					loadingText: '',
					renderTo: x,
					width: 200,
					hideTrigger: true,
					name: 'filter[' + obj.id + ']',
					minChars: 1,
					value: content,
					cls: 'advanced-form-element',
					id: 'combo_' + obj.id
			});
			FilterMemoryMgr.push(combo);

		});

	},
	renderDatetimePicker: function() {

		Date.monthNames = [
			langArray["Jan"],
			langArray["Feb"],
			langArray["Mar"],
			langArray["Apr"],
			langArray["May"],
			langArray["Jun"],
			langArray["Jul"],
			langArray["Aug"],
			langArray["Sep"],
			langArray["Oct"],
			langArray["Nov"],
			langArray["Dec"]
		];

		Date.dayNames = [
			langArray["Sunday"],
			langArray["Monday"],
			langArray["Tuesday"],
			langArray["Wednesday"],
			langArray["Thursday"],
			langArray["Friday"],
			langArray["Saturday"]
		];

		if(Ext.DatePicker){
			Ext.apply(Ext.DatePicker.prototype, {
			  todayText         : langArray["Today"],
			  monthNames        : Date.monthNames,
			  dayNames          : Date.dayNames,
			  cancelText	: langArray["Cancel"]
			});
		}

		var form = Ext.get('gridAdvancedSearch');
		if (form) {
			if (form.dom.style.display != 'none')
			return;
		}

		var objs = Ext.query('.date-picker');
			Ext.each( objs, function(x,index) {
				var obj = Ext.get(x);
				var content = obj.dom.innerHTML;
				obj.dom.innerHTML = "";
				var field = new Ext.form.DateField({
				editable: false,
				format: 'Y-m-d',
				renderTo: x,
				width: 100,
				name: 'filter[' + obj.id + ']',
				value: content,
				cls: 'advanced-form-element',
				id: 'combo_' + obj.id
			});
			FilterMemoryMgr.push(field);
		});

	},
	adjustGridLayout: function() {

		var header = Ext.get('gridHeaderBox');
		if (!header)
			return;
		var tbar = Ext.get('gridToolbar');
		if (!tbar)
			return;

		tbar.setWidth( header.getWidth() );

		var body = Ext.getBody();
		if (!body)
			return;
		var tableBody = Ext.get('gridTableBody');
		if (!tableBody)
			return;
		var newSize = body.getHeight()-130;

		if (tableBody.getHeight()>=newSize) {
			tableBody.setHeight(newSize);
			return;
		}

		if (tableBody.dom.style.removeAttribute)
			tableBody.dom.style.removeAttribute("height");
		else
			tableBody.dom.style.removeProperty("height");

	},
	editServices: function() {
		var props = {};
		var selectedServices;

		selectedServices = Statusgrid.getSelectedServiceDescriptionsOnServiceStatusGrid();
		if (selectedServices.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.action = "editServices";
		props.services = selectedServices;
		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	editHosts: function() {
		var hosts;
		var props = {};

		props.hosts = Statusgrid.getSelectedHostNamesOnHostStatusGrid();
		if (props.hosts.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	addHost: function() {
		var hosts;
		var props = {
			action: 'addHost'
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	cloneService: function() {
		var props = {};
		var selectedServices;

		selectedServices = Statusgrid.getSelectedServiceDescriptionsOnServiceStatusGrid();
		if (selectedServices.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var props = {
			action: 'cloneService',
			services: selectedServices,
			width: 400,
			height: 140
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	cloneHost: function() {

		hosts = Statusgrid.getSelectedHostNamesOnHostStatusGrid();
		if (hosts.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var hosts;
		var props = {
			action: 'cloneHost',
			hostName: hosts[0],
			width: 400,
			height: 180
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},

	delHost: function() {

		if (SelectedElements.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var props = {
			action: 'deleteHosts',
			hosts: SelectedElements,
			width: 250,
			height: 170,
			title: langArray['Remove']
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);

	},
	closeConfigurationWindow: function(success) {
		parent.showSystemAlert(ALERT_OK,langArray['Informations'],langArray['Command submitted successfully']);
		Ext.get("gridRefresh").dom.onclick({});
		Statusgrid.closeConfigurationWindow();
	},
	genReportFromGrid: function(reportType, objectType) {

		var URL = '/opmon/seagull/www/index.php/opreports/action/index/';

		// Set reportType
		URL += '?formTo=' + reportType;

		// Set manualMode
		var manualMode = new Object();
		manualMode.reportType = '0';
		manualMode.timeCutName = '24x7';
		manualMode.reportPeriod	= 'last24hours';
		manualMode.objectType = objectType;
		manualMode.timeCutId = Ext.get('gridReportPeriod').dom.value;
		if (reportType == AVAILREPORT)
			manualMode.reportType = AVAILDETAILED;
		manualMode.selectedItens = SelectedElements;

		if (manualMode.selectedItens.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var param = Ext.util.JSON.encode(manualMode);
		param = param.replace(/\"/g, "'");
		URL += '&manualMode=' + param;

		var frame = parent.Ext.get('mainFrame');
		frame.dom.src = URL;

	},
	runExternalCommand: function(objectType) {

		// Get selected items
		var objects = [];
		objects = SelectedElements;

		if (objects.length) {

			var elements = Ext.util.JSON.encode(objects);
			var win = new Ext.Window({
				applyTo:        'cmdWin',
				id:             'extCmdWin',
				layout:         'fit',
				width:          250,
				autoHeight:     true,
				y:              100,
				buttonAlign:    'center',
				plain:          false,
				modal:          true,
				closable:       false,
				closeAction:    'hide',
				draggable:      false,
				shadow:         false,
				bodyCssClass:   'ext-window',
				bodyBorder:     false,
				hideBorders:    true,
				border:         true,
				resizable:      false,
				autoLoad: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/external_command_list/?',
					method: 'POST',
					params: {elements: elements, objectType: objectType},
					text: langArray['Loading'] + '...',
					nocache: true
				}
			});

			win.on('hide',function() {
				Ext.get('cmdWin').dom.innerHTML = "";
			});

			win.show();

		} else {
			StatusgridEvents.noElementSelected();
		}

	},
	genRealtimeGraph: function() {

		var objects;
		objects = SelectedElements;

		if (objects.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		Ext.each(objects,function(obj,index) {

			if (obj.indexOf("!") != -1) {
				var objIds = [];
				objIds = obj.split("!");
				var url = '/opmon/seagull/www/index.php/statusgrid/action/realtimegraph';
				url += '/host_id/' + objIds[0];
				url += '/service_id/' + objIds[1];
				var win = window.open(url,'','height=340,width=800,scrollbars=no,menubar=no,resizable=yes,toolbar=no,location=no,status=no');
			}

		});

	},
	addFavoriteLink: function() {
		if (parent)
			parent.addFavoriteLink();
	},
	addShortcutLink: function() {
		if (parent)
			parent.addShortcutLink();
	}

}
